REM ###########################################################################################################
REM # MSWIN Platform periodically Server Reboot - Shutting down DB/ASM instance + Server Rebooting
REM # Author: Amos Geng
REM # Date: 06/17/2015
REM # Description: The batch file is used to shutdown the Database/ASM instance and reboot the Server 
REM # MiCORE_ENV parameters: ORACLE_HOME, GRID_HOME, LOG_LOCATION, SCRIPT_LOCATION 
REM # MiCORE_ENV parameters: USER_INSTANCES, ASM_INSTANCES, PROACTIVE_REBOOT_EMAIL
REM # MICORE_ENV location must be hard coded
REM ###########################################################################################################

@echo on

goto main

:funct_set_variable
call C:\micore\scripts\micore_env.bat
set filedatetime=%DATE:~10,4%_%DATE:~4,2%_%DATE:~7,2%_%TIME:~0,2%%TIME:~3,2%%TIME:~6,2%
set filedatetime=%filedatetime: =%
set script_name=micore_server_reboot
set script_ver=2.0
set status_log=%LOG_LOCATION%\shutdown_cluster_%filedatetime%.txt
set all_start_services=%SCRIPT_LOCATION%\micore_reboot\all_start_services.bat
set start_services_command=%SCRIPT_LOCATION%\micore_reboot\start_services_command.bat
set asm_exist=no
set css=install
goto:EOF


:funct_log_header
echo ==================================================== > %status_log%
echo * MSWIN Server Periodically Reboot - Reboot          >> %status_log%
echo * Date: %filedatetime%                               >> %status_log%
echo * Server: %computername%                             >> %status_log%
echo ==================================================== >> %status_log%
echo.>> %status_log%
echo.>> %status_log%
echo *********Instance Status********* >> %status_log%
goto:EOF


:funct_asm_exist
for /f "delims=" %%i in ('net start ^| findstr Oracle ^| findstr ASM') do set asm_exist=yes
goto: EOF


:funct_db_status
set ORACLE_SID=%~1
sqlplus -s / as sysdba @%SCRIPT_LOCATION%\micore_reboot\micore_db_status.sql >> %status_log%
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ >> %status_log%
goto:EOF


:funct_asm_status
set ORACLE_SID=%~1
set ORACLE_HOME=%GRID_HOME%
sqlplus -s / as sysasm @%SCRIPT_LOCATION%\micore_reboot\micore_asm_status.sql >> %status_log%
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ >> %status_log%
goto:EOF


:funct_services_running
echo. >> %status_log%
echo. >> %status_log%
echo. >> %status_log%
echo. >> %status_log%
echo *********Services Status********* >> %status_log%
echo. >> %status_log%

::::::::::::::::::::::::::::::::::::::::::::::

echo.> %all_start_services%
for /f "delims=" %%i in ('sc query ^| findstr Oracle ^| findstr SERVICE_NAME') do echo %%i >> %all_start_services%

echo.> %start_services_command%

for /F "delims=" %%i in (%all_start_services%) do (
	call :funct_remove_servicename "%%i"
)
::::::::::::::::::::::::::::::::::::::::::::::

for /f "delims=" %%i in ('net start ^| findstr Oracle') do echo [Started]%%i >> %status_log%
goto:EOF

:funct_remove_servicename
set string=%~1
set string=%string:SERVICE_NAME:=%
echo %string% >> %start_services_command%
goto:EOF

:funct_crsctl_status
echo. >>  %status_log%
crsctl stat res -t >>  %status_log%
goto:EOF


:funct_shutdown_db
echo. >>  %status_log%
echo. >>  %status_log%
echo. >>  %status_log%
echo *********Shutting Down Database %~1...********* >>  %status_log%
set ORACLE_SID=%~1
echo Database %~1 shutdown >> %status_log%
sqlplus -s / as sysdba @%SCRIPT_LOCATION%\micore_reboot\micore_shutdown.sql >> %status_log%
goto:EOF


:funct_shutdown_asm
echo. >>  %status_log%
echo. >>  %status_log%
echo. >>  %status_log%
echo *********Shutting Down %~1...********* >>  %status_log%
set ORACLE_SID=%~1
set ORACLE_HOME=%GRID_HOME%
echo ASM %~1 shutdown >> %status_log%
sqlplus -s / as sysasm @%SCRIPT_LOCATION%\micore_reboot\micore_shutdown.sql >> %status_log%
goto:EOF


:funct_printing_reboot
echo. >>  %status_log%
echo. >>  %status_log%
echo. >>  %status_log%
echo *********Rebooting server %computername%...********* >>  %status_log%
goto:EOF


:funct_server_reboot
shutdown /r
goto:EOF

::::: Script Entrance from Function Main :::::

:main

call :funct_set_variable
call :funct_log_header

::::::::::::::::::::::::::::::::::::::::::::::::::::::::
set password=%1

if [%password%] EQU [] (
	set /p password="Please enter password to execute server auto-reboot script:"
)

if %password% == emeralit (
	echo Correct Passowrd Entered.
) else (
	echo Incorrect Passord Entered: %password% -- Exiting... >> %status_log%
	
	echo to: %PROACTIVE_REBOOT_EMAIL% > %LOG_LOCATION%\reboot_%filedatetime%.txt
	echo from: sqlmail@emeralit.com >> %LOG_LOCATION%\reboot_%filedatetime%.txt
	echo subject: Proactive - %CLIENT_NAME%:%HOST%:Server is being reboot >> %LOG_LOCATION%\reboot_%filedatetime%.txt
	echo.>> %LOG_LOCATION%\reboot_%filedatetime%.txt
	type %status_log% >> %LOG_LOCATION%\reboot_%filedatetime%.txt
	echo.>> %LOG_LOCATION%\reboot_%filedatetime%.txt
	echo This email was sent by MiCORE monitoring script %script_name% version %script_ver% >> %LOG_LOCATION%\reboot_%filedatetime%.txt
	Msmtp -t < %LOG_LOCATION%\reboot_%filedatetime%.txt
	exit;
)
:::::::::::::::::::::::::::::::::::::::::::::::::::::::

call :funct_asm_exist

for %%i in (%USER_INSTANCES%) do (
	call :funct_db_status %%i
)

if %asm_exist%==yes (
	for %%j in (%ASM_INSTANCES%) do (
		call :funct_asm_status %%j
	)
)

call :funct_services_running

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
echo. >>  %status_log%
echo. >>  %status_log%
echo. >>  %status_log%
echo *********CRSCTL Status********* >>  %status_log%
echo. >>  %status_log%
crsctl check cssd >> %status_log% 2>&1

for /f "delims=" %%i in ('findstr /n "not recognized" %status_log%') do set css=uninstalled

if %css% == uninstalled (
	echo Oracle Cluster is not installed on this server... >> %status_log%
) else (
	call :funct_crsctl_status
)
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::

call C:\micore\scripts\micore_env.bat

for %%i in (%USER_INSTANCES%) do (
	call :funct_shutdown_db %%i
)

if %asm_exist%==yes (
	for %%a in (%ASM_INSTANCES%) do (
		call :funct_shutdown_asm %%a
	)
)

call :funct_printing_reboot

echo to: %PROACTIVE_REBOOT_EMAIL% > %LOG_LOCATION%\reboot_%filedatetime%.txt
echo from: sqlmail@emeralit.com >> %LOG_LOCATION%\reboot_%filedatetime%.txt
echo subject: Proactive - %CLIENT_NAME%:%HOST%:Server is being reboot >> %LOG_LOCATION%\reboot_%filedatetime%.txt
echo.>> %LOG_LOCATION%\reboot_%filedatetime%.txt
type %status_log% >> %LOG_LOCATION%\reboot_%filedatetime%.txt
echo.>> %LOG_LOCATION%\reboot_%filedatetime%.txt
echo This email was sent by MiCORE monitoring script %script_name% version %script_ver% >> %LOG_LOCATION%\reboot_%filedatetime%.txt
Msmtp -t < %LOG_LOCATION%\reboot_%filedatetime%.txt

:: Reboot the server
call :funct_server_reboot

goto:EOF